'use strict'
// NOTE: Keep this es5-compatible so users of old browsers can enjoy

function gotcha(handler) {
  return function (key) {
    if (
    key.target === window.linkToSafety || key.key === 'Tab' // Don't trap keyboard-only users
    || /^Arrow/.test(key.key) // Move cursor in contenteditable
    || key.key == null) // Old browsers might not implement KeyEvent.key
    {
      return
    }

    key.preventDefault()
    key.stopPropagation()
    key.stopImmediatePropagation()

    if (key.target.play && key.key === ' ' && key.type === 'keyup') {
      if (key.target.paused) { key.target.play() } else { key.target.pause() }
    }

    var out = document.createElement('li')
    document.getElementsByClassName('gotcha')[0].appendChild(out)
    if (key.target.className === 'key-event-allowed'
    || key.key === 'Escape'
    || document.fullscreen
    || document.mozFullScreen
    || document.pointerLockElement
    || document.mozPointerLockElement) {
      out.textContent = handler + ' on ' + key.target.tagName + ' is ok '
    } else {
      var blink = document.createElement('blink')
      blink.textContent = handler + ' on ' + key.target.tagName + ' gotcha! '
      out.appendChild(blink)
    }
  }
}

function hijack(target) {
  var name =
      target === window ? 'WINDOW' :
      target === document ? 'DOCUMENT' :
      target.tagName

  target.addEventListener('keydown', gotcha('Keydown for ' + name))
  target.addEventListener('keyup', gotcha('Keyup for ' + name))
  target.addEventListener('keypress', gotcha('Keypress for ' + name))

  target.addEventListener('keydown', gotcha('Keydown for ' + name + ' with capture '), true)
  target.addEventListener('keyup', gotcha('Keyup for ' + name + ' with capture '), true)
  target.addEventListener('keypress', gotcha('Keypress for ' + name + ' with capture '), true)
  
  target.onkeydown = gotcha('Old-school keydown for ' + name)
  target.onkeyup = gotcha('Old-school keyup for ' + name)
  target.onkeypress = gotcha('Old-school keypress for ' + name)
}
